#### read_at (7 of 8 overloads)

Attempt to read a certain amount of data at the specified offset before returning.

    template<
        typename SyncRandomAccessReadDevice,
        typename Allocator,
        typename CompletionCondition>
    std::size_t read_at(
        SyncRandomAccessReadDevice & d,
        uint64_t offset,
        basic_streambuf< Allocator > & b,
        CompletionCondition completion_condition,
        constraint_t< is_completion_condition< CompletionCondition >::value >  = 0);

This function is used to read a certain number of bytes of data from a random access device at the specified offset. The call will block until one of the following conditions is true:

- The completion_condition function object returns 0.

This operation is implemented in terms of zero or more calls to the device's read_some_at function.

###### Parameters

d

  The device from which the data is to be read. The type must support the SyncRandomAccessReadDevice concept.

offset

  The offset at which the data will be read.

b

  The `basic_streambuf` object into which the data will be read.

completion_condition

  The function object to be called to determine whether the read operation is complete. The signature of the function object must be:

      std::size_t completion_condition(
        // Result of latest read_some_at operation.
        const asio::error_code& error,

        // Number of bytes transferred so far.
        std::size_t bytes_transferred
      );

  A return value of 0 indicates that the read operation is complete. A non-zero return value indicates the maximum number of bytes to be read on the next call to the device's read_some_at function.

###### Return Value

The number of bytes transferred.

###### Exceptions

asio::system_error

  Thrown on failure.